;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;X																			  X
;X 	Crated by dotstyler
;X 	Start Date:
;X 	Firmware vers.:
;X 	Description:
;X
;X
;X 	Device:
;X 	Clock: 16MHz
;X 
;X 	Pinout__________________________________
;X 
;X  
;X  Changelog:
;X  ~~~~~~~~~~
;X	Version 0.0.0 (17.04.2009)
;X	==========================
;X - Buffer fix
;X - Speed optimizing
;X - and so on...
;X																			  X
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX


.include "m8def.inc"


.device Atmega8





.cseg

; IRQ____Address_____Routine______________
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
.org	$0000 
	rjmp 	RESET 			; Reset Handler
	reti;jmp EXT_INT0		; IRQ0 Handler
	reti;jmp EXT_INT1		; IRQ1 Handler
.org	$0003
	rjmp TIM2_COMP			; Timer2 Compare Handler
	reti;jmp TIM2_OVF	 	; Timer2 Overflow Handler
	reti;jmp TIM1_CAPT 		; Timer1 Capture Handler
	reti;jmp TIM1_COMPA 	; Timer1 CompareA Handler
	reti;jmp TIM1_COMPB 	; Timer1 CompareB Handler
	reti;jmp TIM1_OVF 		; Timer1 Overflow Handler
	reti;jmp TIM0_OVF 		; Timer0 Overflow Handler
	reti;jmp SPI_STC 		; SPI Transfer Complete Handler
	reti;jmp USART_RXC 		; USART RX Complete Handler 
	reti;jmp USART_UDRE 	; UDR Empty Handler
	reti;jmp USART_TXC 		; USART TX Complete Handler
	reti;jmp ADC_Complete 	; ADC Conversion Complete Handler
	reti;jmp EE_RDY 		; EEPROM Ready Handler
	reti;jmp ANA_COMP 		; Analog Comparator Handler
	reti;jmp TWSI 			; Two-wire Serial Interface Handler
	reti;jmp EXT_INT2 		; IRQ2 Handler
	reti;jmp TIM0_COMP 		; Timer0 Compare Handler
	reti;jmp SPM_RDY 		; Store Program Memory Ready Handler

;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX




.include "Defines.asm"
.include "PWM_CNTR_Routinen.asm"
.include "TWI_RX_CMD_DEC.asm"
.include "TWI_ISR_Pol.asm"
.include "TIM2_COMP_ISR.asm"
.include "TXB_Preload_Routines.asm"
.include "temporary.asm"


RESET:					; Reset Handler


; Watchdog___Initialisierung_______
		ldi		temp, (0<<7|0<<6|0<<5|0<<WDCE|1<<WDE|1<<WDP2|1<<WDP1|1<<WDP0) // Comment
		out		WDTCR, temp


; Stack___pointer______________
		ldi		temp, high(RAMEND)
		out     SPH, temp
		ldi		temp, Low(RAMEND)
		out		SPL, temp

		rcall	TXB_FL_CMD_BE	

;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
; 							Timer Counter Initialisierungen					  X
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX


; Timer Counter 1 Init , MODE 14 Fast PWM , TOP = ICR1
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX	 

		ldi		temp, (1<<COM1A1)|(1<<COM1A0)|(1<<COM1B1)|(1<<COM1B0)|(0<<FOC1A)|(0<<FOC1B)|(1<<WGM11)|(0<<WGM10)
		out		TCCR1A, temp
		ldi		temp, (0<<ICNC1)|(0<<ICES1)|(0<<5)|(1<<WGM13)|(1<<WGM12)|(0<<CS12)|(0<<CS11)|(0<<CS10)  //CS-> .max 5
		out		TCCR1B, temp

; Timer Counter2 Init. , CTC- Mode 
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

		ldi		temp, (0<<FOC2)|(0<<WGM20)|(0<<COM21)|(0<<COM20)|(1<<WGM21)|(0<<CS22)|(0<<CS21)|(0<<CS20)
		out		TCCR2, temp
		ldi		temp, 1<<OCIE2
		out		TIMSK, temp


;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;X 			TWI- Initialisierung			X
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
	
		ldi		temp, (1<<TWINT)|(1<<TWEA)|(1<<TWEN)
		out		TWCR, temp



;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;                            Software Initialisierung
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

; 1.0		
		clr		SREG_1
; Hardware PWM OCR1A,B Update durchfhren
		sbr		SREG_3, 1<<UPDA30			
		sbr		SREG_3, 1<<UPDA31
													// Status Register virgin Mode :-)
		clr		SREG_3
		clr 	temp
		rcall	Power_UP_HW_Settings_load

		lds		temp, Control_Reg_SRAM				//
		sbrs	temp, PWUPL							// PWM- Werte laden beim Hochfahren ? :-)
; PWUPL = 0
		rjmp	PWM_def_Val
; PWUPL = 1
		rcall	Power_UP_PWM_Values_load
		rjmp	In_Out_initialisierungen
;***********************************		
;***********************************
PWM_def_Val:
 		rcall	PWM_Default_val_load

In_Out_initialisierungen:
; Register Initialisierung
; Port Zustand 0
		clr		temp
		out		PortB, temp
		out		PortC, temp
		out		PortD, temp
; DDR- DataDirection Register
; PWM- Kanle 1-8
		ser		temp
		out		DDRD, temp								// Update PortC
; PWM- Kanle 9- 12
		in		temp, DDRC
		andi	temp, (1<<7|1<<6|1<<DDC5|1<<DDC4|0<<DDC3|0<<DDC2|0<<DDC1|0<<DDC0)
		ori		temp, (0<<7|0<<6|0<<DDC5|0<<DDC4|1<<DDC3|1<<DDC2|1<<DDC1|1<<DDC0)
		out		DDRC, temp
; PWM- Kanle 13-18 + OC1A, OC1B(16-Bit PWM Kanle)
		in		temp, DDRB
		andi	temp, (1<<7|1<<6|0<<DDB5|0<<DDB4|0<<DDB3|0<<DDB2|0<<DDB1|0<<DDB0)
		ori		temp, (0<<7|0<<6|1<<DDB5|1<<DDB4|1<<DDB3|1<<DDB2|1<<DDB1|1<<DDB0)
		out		DDRB, temp



		sei	
											// Interrupts Freigabe
;***********************************		
;***********************************
;* 			Hauptprogramm		  **
;***********************************
;***********************************
	

Programm:
		
		WDR									// WATCHDOG Reset

		sbrc	SREG_1, UPDA3				// 
; UPDA3 =1
		rjmp	Prog_A
; UPDA3 =0
		sbrc	SREG_1, UPDA4
; UPDA4 =1
		rjmp	Prog_B
; UPDA4 =0
		rjmp	TWINT_Request

Prog_A:										// UPDA3 =1
		cbr		SREG_1, 1<<UPDA3			// Konfigurationsbereich
		rcall	TWI_RXD_Decoder			
		rjmp	TWINT_Request
Prog_B:										// UPDA4 =1
		cbr		SREG_1, 1<<UPDA4			// Speicherbereich		
		rcall	TWI_RXD_Decoder


TWINT_Request:
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
		in		temp, TWCR
		sbrs	temp, TWINT
		rjmp	Programm
		rcall	TWI_Programm
		rjmp	Programm
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX


				


.exit
