

; Register definitionen_____________
; Hier werden den "General Purpose Working Register" Namen vergeben 

		.def	temp		=r16
		.def    temp2		=r17
		.def	temp3		=r18			
		.def	temp4		=r19
		.def	PWM_Counter =R20    		// PWM Counter, Counts all Timer Counter2 Compare Match events
		.def	PWM_Cnt_Top =R21			// Defines the top of PWM_Counter. Equals CTC- Mode to determine the Resolution
		.def	SREG_1		=R22
		.def	SREG_3		=R23
		.def	Low_Byte	=r24			//  Doppelregister r24, r25	 | Bestimmt fr allgemeine 16- Bit operationen
		.def	High_Byte   =r25			//  Doppelregister r24, r25   | Bestimmt fr allgemeine 16- Bit operationen
;		.def	XL			=r26
;		.def	XH			=r27
;		.def	YL			=r28
;		.def	YH			=r29
;		.def	ZL			=r30
;		.def	ZH			=r31

; PWM_Output Compare Registers
;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx		
		.def	OCR_Ch_1	=R0
		.def	OCR_Ch_2	=R1
		.def	OCR_Ch_3	=R2
		.def	OCR_Ch_4	=R3
		.def	OCR_Ch_5	=R4
		.def	OCR_Ch_6	=R5
		.def	OCR_Ch_7	=R6
		.def	OCR_Ch_8	=R7
		.def	OCR_Ch_9	=R8
		.def	OCR_Ch_10	=R9
		.def	OCR_Ch_11	=R10
		.def	OCR_Ch_12	=R11		
		.def	OCR_Ch_13	=R12
		.def	OCR_Ch_14	=R13
		.def	OCR_Ch_15	=R14
		.def	OCR_Ch_16	=R15

	 
; Define Constant_________
;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx


; SREG_1 Flags 
; SREG_1 ist ein GPReg. Funktionsweise Statusregister
		.equ	UPDA					= 7			// 
		.equ	UPDA2					= 6			// 
		.equ	UPDA3					= 5			//
		.equ	UPDA4					= 4			// Befehl grer als Autoincrement bereich	
		.equ	TWWRG					= 3			// Read only- Wrong operation in TWI- Protocoll.
		.equ	UPDA5					= 2			// Befehlsdecoder Hilfs flag
		.equ	SL_RX					= 1			// Vermerkt das der SR Modus initialisiert wurde
		.equ	SL_TX					= 0			// Vermerkt dass der ST Modus initialisiert wurde
		
		

; SREG_2 Flags. 
; SREG_2 ist ein SRAM Register
		.equ	SPWV						= 0			// Save PWM- Values 
		.equ	SHWS						= 1			// Save Hardware Settings
;		.equ	
		.equ	EWRER						= 3			// Read only- Wenn beim beschreiben des EEPROM's nach 3x Versuchen ein Fehler auftritt.
		.equ	SEWRE						= 7			// PWM oder HW- Werte werden nur bernommen wenn dieses Flag High ist
	


			
; Control Register Flags 
		 .equ	PWUPL						= 0			// Power_Up_load_PWM_values
		 
; SREG_3 Flags
	     .equ	PVWCL						= 0			// PWM- Values write successful
		 .equ	HSWCL						= 1			// Hardware Settings write successful
		 .equ	UPDA30						= 2			// UPDA30= OCR1A- Write Enable
	 	 .equ	UPDA31						= 3			// UPDA31= OCR1B- Write Enable
		 .equ	UPDA32						= 4			// UPDA32= ICR1- Write Enable


; TWI- Status Codes for Slave Transmitter Mode
		.equ	ST_SLA_R_ACK				= $A8		// Own SLA+R has been received; ACK has been returned
		.equ	ST_Arb_Lt_SLA_RW_MST		= $B0		// Arbitration lost in SLA+R/W as Master; own SLA+R has been received; ACK has been returned
		.equ	ST_DATA_ACK					= $B8		// Data byte in TWDR has been transmitted; ACK has been received
		.equ	ST_DATA_NACK				= $C0		// Data byte in TWDR has been transmitted; NOT ACK has been received
		.equ	ST_Last_DB_ACK				= $C8		// Last data byte has been Transmitted(TWEA=0); ACK has been received

; TWI- Status Codes for Slave Receiver Mode
		.equ	SR_SLA_W_ACK				= $60		// Own SLA+W has been received; ACK has been returned
		.equ	SR_Arb_lost_SLA_RW_MST		= $68		// Arbitration lost in SLA+R/W as Master; own SLA+W has been received; ACK has been returned
		.equ	SR_GC_ACK					= $70		// General Call address has been received, ACK has been returned
		.equ	SR_Arb_Lt_SLA_RW_GC			= $78		// Arbitration lost in SLA+R/W as Master; General call address has been received; ACK has been returned
		.equ	SR_Prev_SLA_W_ACK			= $80		// Previously addressed with own SLA+W; data has been received; ACK has been returned
		.equ	SR_Prev_SLA_W_NACK			= $88		// Previously addressed with own SLA+W; data has been received; NOT ACK has been returned
		.equ	SR_Prev_GC_ACK				= $90		// Previously addressed with general call; data has been received; ACK has been returned
		.equ	SR_Prev_GC_NACK				= $98		// Previously addressed with general call; data has been received; NOT ACK has been returned
		.equ	SR_RepSTART_STOP			= $A0		// A STOP condition or repeated START condition has been received while still addressed as Slave
;TWI- Bus Error Code
		.equ	TWI_Bus_error				= $00



; Datenspeicher Zugriffsbefehle(CMD) Startadresse
		.equ	MEM_ACC_CMD				= $81

	

; TWI- Protocoll constants

;		.equ	RX_1st_Byte					= 1
;		.equ	RX_2nd_Byte					= 2

;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;X	    EEPROM_Fixed_Data         X
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX	   

.ESEG	
.org	0x000

CMD_WSP_EEP:		.BYTE 128
	
.equ	CMD_WSP_EEP_SIZE= 128
.equ	CMD_WSP_EEP_END=  0x000+ CMD_WSP_EEP_SIZE

															// 
; GPR PWM- Kanle 
		.equ	OCR_Ch_01_EEP		= CMD_WSP_EEP+ 0			// PWM Kanal 1 Wert
		.equ	OCR_Ch_02_EEP		= CMD_WSP_EEP+ 1			// PWM Kanal 2 Wert
		.equ	OCR_Ch_03_EEP		= CMD_WSP_EEP+ 2			//
		.equ	OCR_Ch_04_EEP		= CMD_WSP_EEP+ 3			//
		.equ	OCR_Ch_05_EEP		= CMD_WSP_EEP+ 4			//
		.equ	OCR_Ch_06_EEP		= CMD_WSP_EEP+ 5			//
		.equ	OCR_Ch_07_EEP		= CMD_WSP_EEP+ 6			//
		.equ	OCR_Ch_08_EEP		= CMD_WSP_EEP+ 7			//
		.equ	OCR_Ch_09_EEP		= CMD_WSP_EEP+ 8			//
		.equ	OCR_Ch_10_EEP		= CMD_WSP_EEP+ 9			//
		.equ	OCR_Ch_11_EEP		= CMD_WSP_EEP+ 10			//
		.equ	OCR_Ch_12_EEP		= CMD_WSP_EEP+ 11			//	
		.equ	OCR_Ch_13_EEP		= CMD_WSP_EEP+ 12			//
		.equ	OCR_Ch_14_EEP		= CMD_WSP_EEP+ 13			//
		.equ	OCR_Ch_15_EEP		= CMD_WSP_EEP+ 14			//
		.equ	OCR_Ch_16_EEP		= CMD_WSP_EEP+ 15			//
; Hardware 16-Bit PWM- Kanle 
		.equ	OCR_Ch_OC1AH_EEP	= CMD_WSP_EEP+ 16			//	Doppelregister
		.equ	OCR_Ch_OC1AL_EEP	= CMD_WSP_EEP+ 17			//	Doppelregister
		.equ	OCR_Ch_OC1BH_EEP	= CMD_WSP_EEP+ 18			//	Doppelregister
		.equ	OCR_Ch_OC1BL_EEP	= CMD_WSP_EEP+ 19			//	Doppelregister

		.equ	Control_Reg_EEP		= CMD_WSP_EEP+ 20			//
		.equ	PWM_CNTR_ADDR_EEP	= CMD_WSP_EEP+ 21			//
		.equ	CS_Soft_PWM_EEP		= CMD_WSP_EEP+ 22			//
		.equ	CS_HW_PWM_16_EEP	= CMD_WSP_EEP+ 23			//
		.equ	Res_HW_PWM_HB_EEP	= CMD_WSP_EEP+ 24			//	Doppelregister
		.equ	Res_HW_PWM_LB_EEP	= CMD_WSP_EEP+ 25			//	Doppelregister
		.equ	Res_Soft_PWM_EEP	= CMD_WSP_EEP+ 26			//
		.equ	PWM_vs_CALC_EEP		= CMD_WSP_EEP+ 27			//
; Alle Register werden im SRAM wiederspiegelt

;*****************
; TWI- EPROM    *
;*****************
.org	0x080

.equ	TW_EEP_Size					= 384			// EEPROM Speichergre

TWI_EEPROM:		.Byte  TW_EEP_Size				// Zugleich auch die Startadresse, SRAM Daten Speicher Bereich









;***************************************************
; Datensegment SRAM					   			   *
;***************************************************

.DSEG		
.ORG SRAM_START									// Ab wo die Daten angelegt werden							
;*******************************************
;*   Arbeitsbereich fr Befehle bis 0xBE   *
;*******************************************
		.equ	CMD_WSP_Size	= $80			// Comand Workspace Size

CMD_Work_SP:	.BYTE CMD_WSP_Size				// Command Workspace


		.equ	OCR_CH_01_SRAM			= CMD_Work_SP+ 0
		.equ	OCR_CH_02_SRAM			= CMD_Work_SP+ 1
		.equ	OCR_CH_03_SRAM			= CMD_Work_SP+ 2
		.equ	OCR_CH_04_SRAM			= CMD_Work_SP+ 3 
		.equ	OCR_CH_05_SRAM			= CMD_Work_SP+ 4 
		.equ	OCR_CH_06_SRAM			= CMD_Work_SP+ 5
		.equ	OCR_CH_07_SRAM			= CMD_Work_SP+ 6
		.equ	OCR_CH_08_SRAM			= CMD_Work_SP+ 7
		.equ	OCR_CH_09_SRAM			= CMD_Work_SP+ 8
		.equ	OCR_CH_10_SRAM			= CMD_Work_SP+ 9
		.equ	OCR_CH_11_SRAM			= CMD_Work_SP+ 10
		.equ	OCR_CH_12_SRAM			= CMD_Work_SP+ 11
		.equ	OCR_CH_13_SRAM			= CMD_Work_SP+ 12
		.equ	OCR_CH_14_SRAM			= CMD_Work_SP+ 13
		.equ	OCR_CH_15_SRAM			= CMD_Work_SP+ 14
		.equ	OCR_CH_16_SRAM			= CMD_Work_SP+ 15
; Hardware 16-Bit PWM- Kanle		
		.equ	OCR_Ch_OC1AH_SRAM		= CMD_Work_SP+ 16
		.equ	OCR_Ch_OC1AL_SRAM 		= CMD_Work_SP+ 17
		.equ	OCR_Ch_OC1BH_SRAM 		= CMD_Work_SP+ 18
		.equ	OCR_Ch_OC1BL_SRAM 		= CMD_Work_SP+ 19		// 20'es Byte
; Hardware Settings
		.equ	Control_Reg_SRAM		= CMD_Work_SP+ 20
		.equ	PWM_CNTR_ADDR_SRAM		= CMD_Work_SP+ 21
		.equ	CS_Soft_PWM_SRAM		= CMD_Work_SP+ 22
		.equ	CS_HW_PWM_16_SRAM  		= CMD_Work_SP+ 23
		.equ	Res_HW_PWM_HB_SRAM		= CMD_Work_SP+ 24
		.equ	Res_HW_PWM_LB_SRAM		= CMD_Work_SP+ 25
		.equ	Res_Soft_PWM_SRAM		= CMD_Work_SP+ 26
		.equ	PWM_vs_CALC_SRAM		= CMD_Work_SP+ 27
		.equ	SREG_2_SRAM				= CMD_Work_SP+ 28			// Ohne GPReg 
;  TWI-Protokoll Relevante Variablen
		.equ	TWI_RX_CMD_copy			= CMD_Work_SP+ 29			// beinhaltet den selben Wert wie "TWI_RX_CMD"
		.equ	ByteCNTR_save			= CMD_Work_SP+ 30			// Byte Counter Wert nach Stop, Unsigned Char
		.equ	TXData_var				= CMD_Work_SP+ 31			// Zu bertragenden Daten am MasterRX


;*************************
;  RXB Empfangspuffer    *
;*************************

		.equ	TW_RXB_Size				= $80						// TWO Wire RX Buffer Size

TW_RX_BUF:		.BYTE TW_RXB_Size									// Two_Wire RX Buffer
							
		.equ	TW_RXB_END				= TW_RX_BUF+ TW_RXB_Size	// TWO Wire RX Buffer Ende

		.equ	TWI_RX_CMD				= TW_RX_BUF+0				// TW_RX_BUF +0 ist gleich Command Variable
		.equ	TWI_RXB_Data			= TW_RX_BUF+1				// Bereich fr empfangene Daten



;*********************
;   TXB SendeBuffer  *
;*********************
		.equ	TW_TXB_Size				= $80						// TWO Wire TX Buffer Size

TW_TX_BUF:		.BYTE TW_TXB_Size									// Two_Wire TX Buffer

		.equ	TW_TXB_END				=TW_TX_BUF+ TW_TXB_Size		// TWO Wire TX Buffer Ende


;*********************
;   	Temporary	 *
;*********************
		.equ	Temp_Size		    	= $20							// 32 Byte

Temporary:		.BYTE Temp_Size										// Temporrer Speicherbereich
;***************************************************
; Erweiterter Flchtiger Daten Speicher IIC		   *
;***************************************************
		.equ	SRAM_DS_Size		    = $1E0

SRAM_DS:		.BYTE SRAM_DS_Size				// Zugleich auch die Startadresse, SRAM Daten Speicher Bereich

		.equ	SRAM_DS_END				= SRAM_DS+ SRAM_DS_Size		// SRAM Datenspeicher ende
		




.CSEG
