;TWSI:

TWI_Programm:

; TWINT wurde gesetzt Status Register auswerten und entsprechend reagieren
		in		temp, TWSR								// TWSR - Ausgelesen
		andi	temp, $F8								//
							
		sbrs	SREG_1, TWWRG							//
		rjmp	TWI_Programm_main						//
; IF TWWRG equals 1										//
		cpi		temp, TWI_Bus_error						//
		Breq	TWI_Bus_error_HDR_2						//
														//
		cpi		temp, SR_SLA_W_ACK						//
		Breq	SR_RX_Init_HDR_2						//
; Alles andere ist unterwnscht							//
		ldi		temp, (1<<TWINT)|(1<<TWEA)|(1<<TWEN)	// TWINT lschen, 
		out		TWCR, temp								// ACK- Controlled by Slave Receiver
	ret
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
TWI_Bus_error_HDR_2:
		rcall	TWI_Bus_error_HDR						//
	ret
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
SR_RX_Init_HDR_2:
		sbr		SREG_1, 1<<SL_RX						//
		andi	SREG_1, (0<<UPDA|0<<UPDA2|1<<UPDA3|1<<UPDA4|0<<TWWRG|1<<UPDA5|1<<SL_RX|1<<SL_TX)	// Lsche UPDA, UPDA2 und TWWRG
		ldi		XL, Low (TW_RX_BUF)						//
		ldi		XH, High (TW_RX_BUF)					//
		clr		temp3									// Bytecounter
		ldi		temp, (1<<TWINT)|(1<<TWEA)|(1<<TWEN)	// TWINT lschen, 
		out		TWCR, temp								// ACK- Controlled by Slave Receiver
		ret

TWI_Programm_main:
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
; TWI- Status Codes for Slave Receiver Mode
		cpi 	temp, SR_SLA_W_ACK							// Own SLA+W has been received; ACK has been returned
		Breq	SR_RX_Init_TAB
					
		cpi 	temp, SR_Arb_lost_SLA_RW_MST				// Arbitration lost in SLA+R/W as Master; own SLA+W has been received; ACK has been returned
		Breq	SR_Arbitr_lost_TAB
			
		cpi 	temp, SR_Prev_SLA_W_ACK						// Previously addressed with own SLA+W; data has been received; ACK has been returned
		Breq	SR_DATA_ACK_TAB
	
		cpi 	temp, SR_Prev_SLA_W_NACK					// Previously addressed with own SLA+W; data has been received; NOT ACK has been returned
		Breq	SR_DATA_NACK_TAB
				
		cpi 	temp, SR_RepSTART_STOP						// A STOP condition or repeated START condition has been received while still addressed as Slave
		Breq	SR_RepSTART_STOP_TAB

; TWI- Status Codes for Slave Transmitter Mode
;**********************************************
		cpi 	temp, ST_SLA_R_ACK							// Own SLA+R has been received; ACK has been returned
		Breq	ST_TX_init_TAB

		cpi 	temp, ST_Arb_Lt_SLA_RW_MST					// Arbitration lost in SLA+R/W as Master; own SLA+R has been received; ACK has been returned
		Breq	ST_Arb_Lt_SLA_RW_MST_TAB

		cpi 	temp, ST_DATA_ACK							// Data byte in TWDR has been transmitted; ACK has been received
		Breq	ST_DATA_ACK_TAB

		cpi 	temp, ST_DATA_NACK							// Data byte in TWDR has been transmitted; NOT ACK has been received
		Breq	ST_DATA_NACK_TAB

		cpi 	temp, ST_Last_DB_ACK						// Last data byte has been Transmitted(TWEA=0); ACK has been received
		Breq	ST_Last_DB_ACK_TAB

		cpi 	temp, TWI_Bus_error							// Bus ERROR
		Breq	TWI_Bus_error_TAB

; Kein Treffer 
		ldi		temp, (1<<TWINT)|(1<<TWEA)|(1<<TWEN)
		out		TWCR, temp
	ret

;***************************************************************
;* Tablelle fr weitere Sprnge	da Branch nicht ausreicht 64+  *
;***************************************************************
SR_RX_Init_TAB:
		rjmp	SR_RX_Init_HDR

SR_Arbitr_lost_TAB:							
		rjmp	SR_Arbitr_lost_HDR							// HDR- Handler
	
SR_DATA_ACK_TAB:
		rjmp	SR_DATA_ACK_HDR

SR_DATA_NACK_TAB:
		rjmp	SR_DATA_NACK_HDR

SR_RepSTART_STOP_TAB:
		rjmp	SR_RepSTART_STOP_HDR

;***************************
ST_TX_init_TAB:
		rjmp	ST_TX_init_HDR

ST_Arb_Lt_SLA_RW_MST_TAB:
		rjmp	ST_Arb_Lt_SLA_RW_MST_HDR

ST_DATA_ACK_TAB:
		rjmp	ST_DATA_ACK_HDR

ST_DATA_NACK_TAB:
		rjmp	ST_DATA_NACK_HDR

ST_Last_DB_ACK_TAB:
		rjmp	ST_Last_DB_ACK_HDR

;***************************
TWI_Bus_error_TAB:
		rjmp	TWI_Bus_error_HDR

;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX


; Alle Statuscode ohne Zuordnung 
;--------------------------------
SR_Arbitr_lost_HDR:										// Arbitration lost in SLA+R/W as Master; own SLA+W has been received; ACK has been returned
SR_DATA_NACK_HDR:										// Previously addressed with own SLA+W; data has been received; NOT ACK has been returned
ST_Arb_Lt_SLA_RW_MST_HDR:								// Arbitration lost in SLA+R/W as Master; own SLA+R has been received; ACK has been returned
ST_Last_DB_ACK_HDR:										// Last data byte has been Transmitted(TWEA=0); ACK has been received


		ldi		temp, (1<<TWINT)|(1<<TWEA)|(1<<TWEN)
		out		TWCR, temp
	ret


;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

;******************************************************
; Slave Repeated Start Stop Conidtion				  *
;******************************************************
SR_RepSTART_STOP_HDR:
		sts		ByteCNTR_save, temp3					// Save ByteCounter
; RX_CMD >= MEM_ACC_CMD ?
		lds		temp, TWI_RX_CMD_copy					//
		cpi		temp, MEM_ACC_CMD						//	
		Brsh	SRRSSH_A								// RX_CMD is same or higher MEM_ACC_CMD(Befehls- Bereich Konfiguration)
;RX_CMD < MEM_ACC_CMD									// SRRSSH_B
; ByteCounter =1 ?
		cpi		temp3, 1								// 
		Breq	SRRSSH_C								//
; ByteCounter not equal 1								// SRRSSH_D
; ByteCounter >=2 ?
		cpi		temp3, 2								//
		BRSH	SRRSSH_E
; ByteCounter is not Same or Higher 2					// SRRSSH_F
		sbr		SREG_1, 1<<TWWRG						//		
		ldi		temp, (1<<TWINT)|(1<<TWEA)|(1<<TWEN)
		out		TWCR, temp	
	ret

SRRSSH_E:												// Schreibbefehl Kofigurationsbereich 
;		rcall	TWI_RXD_Decoder
		sbr		SREG_1, 1<<UPDA3
		ldi		temp, (1<<TWINT)|(1<<TWEA)|(1<<TWEN)
		out		TWCR, temp	
	ret
SRRSSH_C:
		sbr		SREG_1, 1<<UPDA							// Lesebefehl Konfigurationsbereich
		ldi		temp, (1<<TWINT)|(1<<TWEA)|(1<<TWEN)
		out		TWCR, temp	
	ret

SRRSSH_A:												// RX_CMD is same or higher MEM_ACC_CMD(Befehls- Bereich Konfiguration)
		cpi		temp3, 2
		Breq	SRRSSH_J								// SRRSSH_I
		cpi		temp3, 3								
		Breq	SRRSSH_K	
; Byte Counter not equal 3
; Byte Counter >= 4 ?									// SRRSSH_L
		cpi		temp3, 4
		Brsh	SRRSSH_M
; Byte Counter kleiner 4								// SRRSSH_N
		sbr		SREG_1, 1<<TWWRG						//		
		ldi		temp, (1<<TWINT)|(1<<TWEA)|(1<<TWEN)
		out		TWCR, temp	
	ret

SRRSSH_J:												// 
SRRSSH_M:												// Schreibbefehl Speicherbereich
;		rcall	TWI_RXD_Decoder
		sbr		SREG_1, 1<<UPDA4
		ldi		temp, (1<<TWINT)|(1<<TWEA)|(1<<TWEN)
		out		TWCR, temp	
	ret

SRRSSH_K:												// Lesebefehl Speicherbereich
		sbr		SREG_1, 1<<UPDA2
		ldi		temp, (1<<TWINT)|(1<<TWEA)|(1<<TWEN)
		out		TWCR, temp	
	ret
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

SR_RX_Init_HDR:		//Own SLA+W has been received; ACK has been returned
		sbr		SREG_1, 1<<SL_RX						//
		andi	SREG_1, (0<<UPDA|0<<UPDA2|1<<UPDA3|1<<UPDA4|0<<TWWRG|1<<UPDA5|1<<SL_RX|1<<SL_TX)	// Lsche UPDA, UPDA2 und TWWRG
		ldi		XL, Low (TW_RX_BUF)						//
		ldi		XH, High (TW_RX_BUF)					//
		clr		temp3									// Bytecounter
		ldi		temp, (1<<TWINT)|(1<<TWEA)|(1<<TWEN)	// TWINT lschen, 
		out		TWCR, temp								// ACK- Controlled by Slave Receiver
		ret
	ret



SR_DATA_ACK_HDR:										// Previously addressed with own SLA+W; data has been received; ACK has been returned									// Daten empfangen
		in		temp, TWDR								// Daten einlesen	
		inc		temp3									// Erhhe ByteCounter um 1
		cpi		temp3, TW_RXB_Size						// Maximale Packetlnge whrend eines Zugriffs.
		BRSH	SR_PL_err
		cpi		temp3, 1								// First received Data Byte
		Breq	SR_DATA_ACK_HDR_BCeq1
SR_DATA_ACK_HDR2:										// Nachdem das CMD Byte Kopiert wurde sollten das RX Byte ins Buffer gespeichert werden
		st		X+, temp								// Empfangene Daten im SRAM ablegen, und Pointer um 1 erhhen
		ldi		temp, (1<<TWINT)|(1<<TWEA)|(1<<TWEN)	// TWINT lschen, 
		out		TWCR, temp								// ACK- Controlled by Slave Receiver
	ret

SR_DATA_ACK_HDR_BCeq1:									// ByteCounter equal 1
		sts		TWI_RX_CMD_copy, temp					// Empfangenes Byte = CMD wird ausserhalb des Empfangsbuffers gesichert
		rjmp	SR_DATA_ACK_HDR2

SR_ByteCounter_err:
		sbr		SREG_1, 1<<TWWRG
		ldi		temp, (1<<TWINT)|(1<<TWEA)|(1<<TWEN)	// TWINT lschen, 
		out		TWCR, temp								// ACK- Controlled by Slave Receiver
	ret

SR_PL_err:												// Wenn gleich oder wie 255 Bytes empfangen wurden
		sbr		SREG_1, 1<<TWWRG
		ldi		temp, (1<<TWINT)|(1<<TWEA)|(1<<TWEN)	// TWINT lschen, 
		out		TWCR, temp								// ACK- Controlled by Slave Receiver
	ret



;*****************************************************
;* SLAVE TRANSMITTER Routinen						 *
;*****************************************************


ST_TX_init_HDR:
		sbr		SREG_1, 1<<SL_TX						//
; SREG_1 UPDA =1 ?
		sbrc	SREG_1, UPDA
; UPDA = 1												
		rjmp	STTIH_A									// STTIH_A
; UPDA = 0
; UPDA2 =1?
		sbrc	SREG_1, UPDA2
; UPDA2 = 1		
		rjmp	STTIH_C									// STTIH_C
; UPDA2 = 0
		sbr		SREG_1, 1<<TWWRG
		ldi		temp, (1<<TWINT)|(1<<TWEA)|(1<<TWEN)	// TWINT lschen, 
		out		TWCR, temp								// ACK- Controlled by Slave Receiver
	ret

STTIH_A:												// Copy Konfigurations Daten ins Sendebuffer
STTIH_C:
		rcall	TXB_Preload								// Transmitt Buffer preload
		ldi		XL, Low (TW_TX_BUF)						//
		ldi		XH, High (TW_TX_BUF)					//
		ld		temp, X+
		out		TWDR, temp
		ldi		temp, (1<<TWINT)|(1<<TWEA)|(1<<TWEN)	// TWINT lschen, 
		out		TWCR, temp								// ACK- Controlled by Slave Receiver
	ret

												// Copy Speicherbereich ins Sendebuffer

					
ST_DATA_ACK_HDR:
		cpi		temp3, TW_TXB_Size
		Breq	STDAH_A
STDAH_B:												// Dises Label wird nicht aufgerufen
		inc		temp3
		ld		temp, X+								
		out		TWDR, temp
		ldi		temp, (1<<TWINT)|(1<<TWEA)|(1<<TWEN)
		out		TWCR, temp	
	 ret

STDAH_A:
		sbr		SREG_1, 1<<TWWRG
		ldi		temp, (1<<TWINT)|(1<<TWEA)|(1<<TWEN)
		out		TWCR, temp	
	ret

ST_DATA_NACK_HDR:										// Erstes oder letzes Byte senden.
		sbr		SREG_1, 1<<TWWRG
		ldi		temp, (1<<TWINT)|(1<<TWEA)|(1<<TWEN)
		out		TWCR, temp	
	ret	

ST_ByteCounter_err:
		sbr		SREG_1, 1<<TWWRG
		ldi		temp, (1<<TWINT)|(1<<TWEA)|(1<<TWEN)	// TWINT lschen, 
		out		TWCR, temp								// ACK- Controlled by Slave Receiver
	ret	
	
TWI_Bus_error_HDR:
		ldi 	temp, (1<<TWINT)|(1<<TWEA)|(1<<TWEN)|(1<<TWSTO)	// TWI STOP
		out		TWCR, temp
	ret


